﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.VisualBasic; //参照設定の追加で、.NET の中から Microsoft.VisualBasic を追加  VB　InputBox の利用


// ssrOS1 Visual C# c1.00   2011/08/03


//ADunit　コミニケーション仕様
// COMポート　19200bps　

//A/Dからのデータ
//   ## ２文字のHexを１データとし、ひとかたまりの終わりをCrLf
//　　A/Dからのコマンドは　External　Trigger　だけ　　　XTとする

// PCからの設定コマンド    ADunit側で受付可能かが分らないので、設定変更時処理は　Stop/Start　と同じとする。
// コマンドは　　**Lf　の３文字    全てエコーバックを待つ
//-------------
//Version 要求　MM　応答　####Lf　　--- ##.#

//Tscale		時間設定	サンプリング	画面
//
//	T1			0.5mS/div	0.025mS	１００ポイント＋１
//	T2			1mS			0.05mS	１６６
//	T3			5			0.1mS	２５０　　　　
//	T4			10			0.2mS	２５０　
//	T5			50			1mS		２５０
//	T6			100			2mS		２５０
//	T7			500			10mS	２５０　--ここからADunitはリアルタイム送信       　　
//	T8			1000		10mS	５００　
//	T9			<<Sec		10mS	Sec倍でT軸をひとつ進める、ADは平均化

//電圧値要求　　　
//　QQ　　測定開始　　　　応答 データ　####Lf　　

//Trigger   　
//	GE:Externa G0：フリーラン　　　　              
//	G1からG9：10%～90%
//	N1からN9：-10%～-90%
//	UP、DN   : 方向
//レンジ
//	R0,R1,R2:Range 0.2,　2,　20 V/F 
//Vシフト
//	V1,V2,V4　　1/1,　1/2,　1/4　
//開始
//	ST  
//終了
//	PU     P送信後　エコーバックを待つ

//Display　仕様
//　波形表示画面　５００（ｔ）＊４００（ｖ）　　中点：200　１Div(t)=100　１Div(v)=100
//                

//
//　時間割り込み1　設定1０ｍS　　　




namespace ssrOS1c
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }


        String Version = "c1.00";

        int Measure;
        String Vshift;
        float Vscale;

        String Tscale;
        int TpointInc; // 時間軸スキップコマ
        int AccCnt; // 平均回数
        int AccCntB;
        int iAD; // AD 501点の格納
        float Tunit; // サンプリング時間

        int TriggerL;
        String TriggerDir; // Up or Down
        int Triggered; //  0:初期状態　1:レベルを超える前のレベル　2:トリガー開始

        Char[] RdChr = new char[6];
        int[] AD = new int[501]; // AD unit からの生データとする
        float AccAD;
        int MaxF = 0;
        int MaxPoint;
        int MinPoint;

        int Zero;
        String ZeroR0;  // レンジ０の　Zero点　--ファイルに格納 10進数変換後
        String ZeroR1;
        String ZeroR2;

        String Vref;  // 基準電圧点　--ファイルに格納 10進数変換後
        float Kfactor;  // A/D データの補正係数　　真値＝（A/DデーターZeor点）＊K   100/Full slace

        String DataDir = ""; //　波形データファイルのフォルダ
        String DataFile;
        String DataNo = "1";
        int DataNoB = 0;
        String CurrentF;


        private void Form1_Load(object sender, EventArgs e)  //-------C#の場合　イベントハンドラの設定を　Form1のプロパティーで設定する。（Basicでは不要　自動的に設定）
        {
            Microsoft.Win32.SystemEvents.PowerModeChanged += new Microsoft.Win32.PowerModeChangedEventHandler(SystemEvents_PowerModeChanged);
            //------スリープのイベントハンドラの定義　（Basicでは不要　自動的に設定）

            String SetPara = Application.UserAppDataPath + "Set_Ocillo_c.ini";
            if (System.IO.File.Exists(SetPara))
            {
                try
                {
                    using (StreamReader F_Oci = new System.IO.StreamReader(SetPara, System.Text.Encoding.Default))
                    {
                        comboBoxPort.Text = F_Oci.ReadLine();
                        comboBoxMode.Text = F_Oci.ReadLine();
                        comboBoxTscale.Text = F_Oci.ReadLine();
                        textBoxTime.Text = F_Oci.ReadLine();

                        string a = F_Oci.ReadLine();
                        if (a == "true") { radioButtonUp.Checked = true; }
                        else { radioButtonUp.Checked = false; }

                        a = F_Oci.ReadLine();
                        if (a == "true") { radioButtonDown.Checked = true; }
                        else { radioButtonDown.Checked = false; }

                        comboBoxTrigger.Text = F_Oci.ReadLine();

                        a = F_Oci.ReadLine();
                        if (a == "true") { checkBoxEXT.Checked = true; }
                        else { checkBoxEXT.Checked = false; }

                        comboBoxRange.Text = F_Oci.ReadLine();
                        DataDir = F_Oci.ReadLine();
                        DataFile = F_Oci.ReadLine();
                        DataNo = F_Oci.ReadLine();
                        ZeroR0 = F_Oci.ReadLine();
                        ZeroR1 = F_Oci.ReadLine();
                        ZeroR2 = F_Oci.ReadLine();
                        Vref = F_Oci.ReadLine();
                    }
                }
                catch (Exception ex) { toolTip1.Show(ex.Message, this, 100, 44, 300000); }
            }
            else { MessageBox.Show("ssrOs1を始めてお使いになりますので、必ずHelpを参照し測定の前には校正（Calibration)を行ってください。"); }
        }


        private void buttonStart_Click(object sender, EventArgs e)
        {
            if (Vref == "" || ZeroR1 == "") { MessageBox.Show("Need calibration in Set menu"); goto Abort; }

            if (Measure == 0) { Start(); Measure = 1; }
            textBox1.Text = "";
        Abort: ;
        }

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // F9ボタンをショートカットキーとして処理する
            if ((int)keyData == (int)ConsoleKey.F9)
            {
                if (Vref == "" || ZeroR1 == "") { MessageBox.Show("Need calibration in Set menu"); goto Abort; }

                if (Measure == 0) { Start(); Measure = 1; }
                textBox1.Text = "start";
            Abort: ;
            }
            return base.ProcessCmdKey(ref msg, keyData);

        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            if (Measure == 1) { Pause(); }
            Measure = 0;
        }

        private void Start()
        {

            serialPort.PortName = comboBoxPort.Text;

            serialPort.DtrEnable = true;
            serialPort.RtsEnable = true;
            serialPort.Open();

            TimeSet();
            Command("T" + Tscale);

            if(checkBoxEXT.Checked == true) { Command("GE");}
            else
            {   TriggerL = Convert.ToInt32(comboBoxTrigger.Text) / 10;
                if (TriggerL >= 0) { Command("G" + TriggerL.ToString());}
                else { Command("N" + TriggerL.ToString().Substring(1, 1));}
            }

    
            if (radioButtonUp.Checked == true ){Command("UP"); TriggerDir = "Up";}

            if (radioButtonDown.Checked == true) {Command("DN"); TriggerDir = "Down";}

            Triggered = 0;

            String r = "0";
            if (Vscale > 0.3F) { r = "1";}
            if (Vscale > 3F) { r= "2";}
            Command("R" + r);

            Vshift = "1";
            if (Convert.ToInt32(Vscale * 10) == 1 || Convert.ToInt32(Vscale) == 1 || Convert.ToInt32(Vscale) == 10)  { Vshift = "2";}
            if (Convert.ToInt32(Vscale * 100) == 5 || Convert.ToInt32(Vscale * 10) == 5 || Convert.ToInt32(Vscale) == 5) { Vshift = "4";}
            Command("V" + Vshift);


            Kfactor = 1.85F / (Convert.ToSingle(Vref) - Convert.ToSingle(ZeroR1));

            Zero = Convert.ToInt32(ZeroR1);
            if (Vscale < 0.3) {Zero = Convert.ToInt32(ZeroR0);}
            if (Vscale > 3) {Zero = Convert.ToInt32(ZeroR2);}

            Command("ST");

            ScaleDraw3();
            buttonStart.ForeColor = Color.Red;
            buttonStart.Text = "Measure";

            if (MaxF == 1 ) { MaxF = 0;  buttonMax.Text = "Set";}
            MaxPoint = -100;
            MinPoint = 100;

            timer1.Enabled = Enabled;
            iAD = 0;
            AccCntB = AccCnt;
            if (Tscale == "7")  //  最初のデータをノイズとして捨てる
            {
                while (serialPort.BytesToRead < 2) {}
                serialPort.Read(RdChr, 0, 2);
            }
        }

        private void Pause()
        {
            timer1.Enabled = false;
            serialPort.Write("P");  //-----Pを送信し、エコーを待つ
        Repeat:
            while (serialPort.BytesToRead < 1) { }
            serialPort.Read(RdChr, 0, 1);
            if (RdChr[0] != 'P') { goto Repeat; }
            serialPort.Write("U");
            while (serialPort.BytesToRead < 1) { }
            serialPort.Read(RdChr, 0, 1);
            serialPort.Write("\n");
            while (serialPort.BytesToRead < 1) { }
            serialPort.Read(RdChr, 0, 1);
            buttonStart.ForeColor = Color.Black;
            buttonStart.Text = "Start(F9)";
            serialPort.Close();
        }

        // RdChr(0) & RdChr(1)の16進表記文字列を10進数に変換　0～F以外の文字がある場合は256とする。
        private int RecNum()
        {
            int num16;
            if (((RdChr[0] > '/' && RdChr[0] < ':') || (RdChr[0] > '@' && RdChr[0] < 'G')) && 
           ((RdChr[1] > '/' && RdChr[1] < ':') || (RdChr[1] > '@' && RdChr[1] < 'G')))
            {
                String a = Convert.ToString(RdChr[0]) + Convert.ToString(RdChr[1]);
                num16 = Convert.ToInt32(a, 16);
            }
            else { num16 = 256; }

            return num16;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int AD0;
            int AD1;

            Graphics gD = pictureBoxD.CreateGraphics();
            timer1.Enabled = false;
        Repeat:
            if (serialPort.BytesToRead < 2) { goto Abort1; }
            serialPort.Read(RdChr, 0, 2);

            if (RdChr[0] == 'X')
            {          //---ADunit からのExternal　Trigger
                Triggered = 2;
                goto Repeat;
            }

            AD0 = RecNum();
            if (AD0 == 256)  //  Error]
            {
                buttonStart.ForeColor = Color.Red;
                buttonStart.Text = "Error";
                goto Abort2;
            }
            if (TpointInc >= 1) { AD[iAD] = AD0; }  // 2sec　以上は平均化する
            else
            {
                AccAD = AccAD + Convert.ToSingle(AD0);
                AccCntB--;
                if (AccCntB == 0)
                {
                    AD[iAD] = Convert.ToInt32(AccAD / Convert.ToSingle(AccCnt));
                    AccAD = 0;
                    AccCntB = AccCnt;
                }
                else { goto Repeat; }
            }

            if (Triggered == 2) { goto SkipT; }

            if (Convert.ToInt32(Tscale) > 6)
            {
                if (checkBoxEXT.Checked == true) { goto Repeat; }
                if (comboBoxTrigger.Text != "0") // トリガ処理が必要(T7以上)
                {
                    if (TriggerDir == "Up")
                    {
                        if (Triggered == 0)
                        {
                            if (AD[iAD] > 128 + TriggerL * 10) { goto Repeat; }
                            else { Triggered = 1; goto Repeat; }
                        }
                        else //  Triggered = 1
                        {
                            if (AD[iAD] <= 128 + TriggerL * 10) { goto Repeat; }
                            Triggered = 2;
                        }
                    }
                    else //  Down
                    {
                        if (Triggered == 0)
                        {
                            if (AD[iAD] < 128 + TriggerL * 10) { goto Repeat; }
                            else { Triggered = 1; goto Repeat; }
                        }
                        else //  Triggered = 1
                        {
                            if (AD[iAD] >= 128 + TriggerL * 10) { goto Repeat; }
                            Triggered = 2;
                        }

                    }
                }
            }
        SkipT:
            if (iAD == 0 && AccCntB == AccCnt) { ScaleDraw(); }
            int kAD = iAD - TpointInc;
            if (kAD == iAD) { kAD = iAD - 1; }
            if (iAD > 0 && iAD < 501)
            {
                AD0 = AD[kAD];
                AD1 = AD[iAD];

                switch (Vshift)
                {
                    case "4":
                        AD0 = Convert.ToInt32(Convert.ToSingle(AD0 + 384 - Zero) * Kfactor * 200.0 + 0.5);
                        AD1 = Convert.ToInt32(Convert.ToSingle(AD1 + 384 - Zero) * Kfactor * 200.0 + 0.5);
                        break;

                    case "2":
                        AD0 = Convert.ToInt32(Convert.ToSingle(AD0 + 128 - Zero / 2) * Kfactor * 200.0 + 0.5);
                        AD1 = Convert.ToInt32(Convert.ToSingle(AD1 + 128 - Zero / 2) * Kfactor * 200.0 + 0.5);
                        break;
                    case "1":
                        AD0 = Convert.ToInt32(Convert.ToSingle(AD0 - Zero / 4) * Kfactor * 200.0 + 0.5);
                        AD1 = Convert.ToInt32(Convert.ToSingle(AD1 - Zero / 4) * Kfactor * 200.0 + 0.5);
                        break;
                }

                if (AD0 > 100) { AD0 = 100; }
                if (AD0 < -100) { AD0 = -100; }
                if (AD1 > 100) { AD1 = 100; }
                if (AD1 < -100) { AD1 = -100; }

                gD.DrawLine(Pens.Red, kAD, 200 - 2 * AD0, iAD, 200 - 2 * AD1);
                textBoxLevel.Text = Convert.ToString(Convert.ToSingle(AD1) * Vscale / 100);
                if (MaxF > 0)
                {
                    if (MaxPoint < AD1)
                    {
                        MaxPoint = AD1;
                        gD.DrawLine(Pens.Green, 0, 200 - 2 * MaxPoint, 500, 200 - 2 * MaxPoint);
                    }
                    if (MinPoint > AD1)
                    {
                        MinPoint = AD1;
                        gD.DrawLine(Pens.Green, 0, 200 - 2 * MinPoint, 500, 200 - 2 * MinPoint);
                    }
                }
            }

            iAD += TpointInc;
            if (TpointInc == 0) { iAD++; }

            if (iAD > 500) //-----1画面終了処理
            {
                AccAD = 0;
                AccCntB = AccCnt;
                iAD = 0;
                Triggered = 0;
                if (comboBoxMode.Text == "One Shot")
                {
                    Pause();
                    Measure = 0;
                    SaveData();
                    ReRun(CurrentF); //---イメージ再描画　最小化などで画面が消されるものへの対策　
                    goto Abort2;
                }

            }
            goto Repeat;

        Abort1:
            timer1.Enabled = Enabled;
        Abort2:
            gD.Dispose();

        }

        private void SaveData()
        //----ファイルセーブ　　デスクトップ　Data_Ocillo.csv 
        // 日時,V単位（V）,時間軸設定、Aux時間設定、時間単位(mSec），データ個数,*,*,----データ
        {
            String na;
            if (DataFile == "") { na = Application.UserAppDataPath + @"\ssrOS1."; }
            else
            {
                na = Convert.ToString(DataNoB);
                if (DataNoB < 10) { na = "0" + Convert.ToString(DataNoB); }
                na = DataFile + "_" + na + ".csv";
                DataNoB++;
                if (DataNo == "") { DataNo = "1"; }
                if (DataNoB == Convert.ToInt32(DataNo)) { DataNoB = 0; }
            }
            CurrentF = na;
            DateTime dtToday = DateTime.Today;
            String d = dtToday.ToString("g");
            String v = Convert.ToString(Vscale / 100);
            String Ts = comboBoxTscale.Text;
            String Tb = textBoxTime.Text;
            String t = Convert.ToString(Tunit);
            String N = "500";
            int Vdata;
            if (TpointInc > 0) { N = Convert.ToString(500 / TpointInc); }

            try
            {
                using (StreamWriter F_Oci = new System.IO.StreamWriter(na, false, System.Text.Encoding.Default))
                {
                    F_Oci.WriteLine(d);
                    F_Oci.WriteLine(v);
                    F_Oci.WriteLine(Ts);
                    F_Oci.WriteLine(Tb);
                    F_Oci.WriteLine(t);
                    F_Oci.WriteLine(N);
                    int k = 0;

                    while (k < 500)
                    {
                        Vdata = AD[k];
                        switch (Vshift)
                        {
                            case "4":
                                Vdata = Convert.ToInt32(Convert.ToSingle(Vdata + 384 - Zero) * Kfactor * 200.0 + 0.5);
                                break;
                            case "2":
                                Vdata = Convert.ToInt32(Convert.ToSingle(Vdata + 128 - Zero / 2) * Kfactor * 200.0 + 0.5);
                                break;
                            case "1":
                                Vdata = Convert.ToInt32(Convert.ToSingle(Vdata - Zero / 4) * Kfactor * 200.0 + 0.5);
                                break;
                        }
                        F_Oci.WriteLine(Convert.ToString(Vdata));
                        k += TpointInc;
                        if (TpointInc == 0) { k++; }
                    }
                }
                
            }
            catch (Exception ex) { toolTip1.Show(ex.Message, this, 100, 44, 300000); }
            textBox1.Text = "Saved as " + na;
        }

        private void ReRun(String f)
        {
            int AD0=0; //　プログラム上は初期値は不要だが、エラーとなるので設定
            int AD1;
            String imgPath = Application.UserAppDataPath + "Dimage.bmp";
            if (System.IO.File.Exists(imgPath)) { }
            else
            {
                Bitmap bmp = new Bitmap(1, 1);
                bmp.Save(imgPath, System.Drawing.Imaging.ImageFormat.Bmp);
            }
            System.Drawing.Image img = System.Drawing.Image.FromFile(imgPath);
            pictureBoxD.Image = img;
            Graphics gD;
            pictureBoxD.Image = new Bitmap(pictureBoxD.ClientRectangle.Width, pictureBoxD.ClientRectangle.Height);
            gD = Graphics.FromImage(pictureBoxD.Image);
            ScaleDraw2();

            try
            {
                using (StreamReader F_Oci = new StreamReader(f, System.Text.Encoding.Default))
                {
                    String d = F_Oci.ReadLine();
                    comboBoxRange.Text = Convert.ToString(Convert.ToSingle(F_Oci.ReadLine()) * 100);
                    comboBoxTscale.Text = F_Oci.ReadLine();
                    textBoxTime.Text = F_Oci.ReadLine();
                    String t = F_Oci.ReadLine();
                    String N = F_Oci.ReadLine();
                    int st = 500 / Convert.ToInt32(N);
                    int i = 0;
                    while (i < 500)
                    {
                        AD1 = Convert.ToInt32(F_Oci.ReadLine());
                        if (i > 0) { gD.DrawLine(Pens.Red, i - st, 200 - 2 * AD0, i, 200 - 2 * AD1); }
                        i += st;
                        AD0 = AD1;
                    }
                }
            }
            catch (Exception ex) { toolTip1.Show(ex.Message, this, 100, 44, 300000); }
            gD.Dispose();
        }


        private void comboBoxMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBoxMode.Text == "ReRun")
            {
                if (DataDir == "") { DataDir = Application.UserAppDataPath; }
                OpenFileDialog ofd = new OpenFileDialog();
                ofd.FileName = "";
                ofd.InitialDirectory = DataDir;
                ofd.Filter = "全てのファイル(*.*)|*.*|CSVファイル(*.csv)|*.csv";
                ofd.FilterIndex = 2;
                ofd.Title = "開くファイルを選択してください";

                if (ofd.ShowDialog() == DialogResult.OK)
                {
                    DataDir = ofd.FileName;
                    ReRun(DataDir);
                }
                comboBoxMode.Text = "One Shot";
            }
        }

        private void TimeSet()
        {
            TpointInc = 2;
            AccCnt = 0;

            switch (comboBoxTscale.Text)
            {
                case "0.5":
                    Tscale = "1";
                    TpointInc = 5;
                    Tunit = 0.025f; //--格納データの１ポイントの時間単位　ｍS
                    break;
                case "1":
                    Tscale = "2";
                    TpointInc = 3;
                    Tunit = 0.03f;
                    break;
                case "5":
                    Tscale = "3";
                    Tunit = 0.1f;
                    break;
                case "10":
                    Tscale = "4";
                    Tunit = 0.2f;
                    break;
                case "50":
                    Tscale = "5";
                    Tunit = 1f;
                    break;
                case "100":
                    Tscale = "6";
                    Tunit = 2f;
                    break;
                case "500":
                    Tscale = "7";
                    Tunit = 10f;
                    break;
                case "1000":
                    Tscale = "7";
                    TpointInc = 1;
                    Tunit = 10f;
                    break;
                case "<<Sec":
                    Tscale = "7";
                    if (textBoxTime.Text == "") { textBoxTime.Text = "1"; }
                    textBoxTime.Text = Convert.ToString(Convert.ToInt32(textBoxTime.Text));
                    AccCnt = Convert.ToInt32(textBoxTime.Text);
                    TpointInc = 0;
                    Tunit = Convert.ToSingle(textBoxTime.Text) * 10;
                    break;
            }

        }

        private void comboBoxTscale_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBoxTscale.Text != "<<Sec")
            {
                textBoxTime.Text = "";
                if (Measure == 1) { Pause(); Start(); }
            }
            else
            {
                if (textBoxTime.Text != "" && Measure == 1) { Pause(); Start(); }
            }
        }

        private void textBoxTime_TextChanged(object sender, EventArgs e)
        {
            try { int a = Convert.ToInt32(textBoxTime.Text); }
            catch { textBoxTime.Text = ""; }
            if (textBoxTime.Text != "")
            {
                TimeSet();
                if (Convert.ToInt32(Tscale) > 6 && Measure == 1) { Pause(); Start(); }
            }
        }

        private void Command(String a)  // aは2文字　　　エコーバックを待つ
        {

            Char[] c1 = new Char[1];
            Char[] c2 = new Char[1];
            Char[] c3 = new Char[1];
            serialPort.Write(a.Substring(0, 1));
            while (serialPort.BytesToRead < 1) { }

            serialPort.Read(c1, 0, 1);
            serialPort.Write(a.Substring(1, 1));
            while (serialPort.BytesToRead < 1) { }

            serialPort.Read(c2, 0, 1);

            serialPort.Write("\n");
            while (serialPort.BytesToRead < 1) { }

            serialPort.Read(c3, 0, 1);
            RdChr[0] = c1[0];
            RdChr[1] = c2[0];
        }

        private void ScaleDraw()  // 目盛直接描画
        {
            Graphics gD = pictureBoxD.CreateGraphics();

            gD.FillRectangle(Brushes.Ivory, 0, 0, 500, 400);

            Pen p = new Pen(Color.Blue, 1);
            for (int x = 0; x <= 5; x++) { gD.DrawLine(p, x * 100, 0, x * 100, 400); }
            for (int y = 0; y <= 4; y++) { gD.DrawLine(p, 0, y * 100, 500, y * 100); }

            if (MaxF > 0)
            {
                if (MaxPoint > -100) { gD.DrawLine(Pens.Green, 0, 200 - 2 * MaxPoint, 500, 200 - 2 * MaxPoint); }
                if (MinPoint < 100) { gD.DrawLine(Pens.Green, 0, 200 - 2 * MinPoint, 500, 200 - 2 * MinPoint); }
            }
            gD.Dispose();
        }

        private void ScaleDraw2() //  目盛イメージ描画　イメージファイルは別途設定
        {
            Graphics gD;
            gD = Graphics.FromImage(pictureBoxD.Image);

            gD.FillRectangle(Brushes.Ivory, 0, 0, 500, 400);


            Pen p = new Pen(Color.Blue, 1);
            for (int x = 0; x <= 5; x++) { gD.DrawLine(p, x * 100, 0, x * 100, 400); }
            for (int y = 0; y <= 4; y++) { gD.DrawLine(p, 0, y * 100, 500, y * 100); }

            if (MaxF > 0)
            {
                if (MaxPoint > -100) { gD.DrawLine(Pens.Green, 0, 200 - 2 * MaxPoint, 500, 200 - 2 * MaxPoint); }
                if (MinPoint < 100) { gD.DrawLine(Pens.Green, 0, 200 - 2 * MinPoint, 500, 200 - 2 * MinPoint); }
            }

        }


        private void ScaleDraw3()  // 目盛イメージ描画　
        {
            String imgPath = Application.UserAppDataPath + "Dimage.bmp";
            if (System.IO.File.Exists(imgPath)) { }
            else
            {
                Bitmap bmp = new Bitmap(1, 1);
                bmp.Save(imgPath, System.Drawing.Imaging.ImageFormat.Bmp);
            }
            System.Drawing.Image img = System.Drawing.Image.FromFile(imgPath);
            pictureBoxD.Image = img;
            Graphics gD;
            pictureBoxD.Image = new Bitmap(pictureBoxD.ClientRectangle.Width, pictureBoxD.ClientRectangle.Height);
            gD = Graphics.FromImage(pictureBoxD.Image);

            ScaleDraw2();
            gD.Dispose();
        }


        private void pictureBoxD_Click(object sender, EventArgs e)
        {
            Point p = PointToClient(System.Windows.Forms.Cursor.Position);
            Graphics g = pictureBoxD.CreateGraphics();

            int x = p.X - 106;
            int y = p.Y - 144;

            Single V = (200 - Convert.ToSingle(y)) / 200 * Vscale;

            String DspXY = " " + Convert.ToString(V) + "V";

            Font fnt = new Font("MS UI Gothic", 10); //フォントオブジェクトの作成

            g.DrawString(DspXY, fnt, Brushes.Green, x, y);//文字列を位置(x,y)、緑色で表示
            g.DrawLine(Pens.Green, x - 2, y, x + 2, y);

            fnt.Dispose();
            g.Dispose();
        }


        private void buttonMax_Click(object sender, EventArgs e)
        {
            MaxPoint = -100;
            MinPoint = 100;
            if (MaxF == 1)
            {
                MaxF = 0;
                buttonMax.Text = "Set";
            }
            else
            {
                buttonMax.Text = "Clear";
                MaxF = 1;
            }
        }


        private void comboBoxTrigger_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (Measure == 1)
            { 
                Pause(); 
                Start(); 
            }
        }


        private void checkBoxEXT_CheckedChanged(object sender, EventArgs e)
        {
            if (Measure == 1)
            {
                Pause();
                Start();
            }
        }


        private void radioButtonUp_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void radioButtonDown_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void textBoxLevel_TextChanged(object sender, EventArgs e)
        {

        }


        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Vscale = Convert.ToSingle(comboBoxRange.Text);

            if (Measure == 1)
            {
                Pause();
                Start();
            }
        }


        private void SystemEvents_PowerModeChanged(object sender, Microsoft.Win32.PowerModeChangedEventArgs e)
        {

            if (e.Mode == Microsoft.Win32.PowerModes.Suspend && Measure == 1)
            {
                Pause();
                Measure = 0;
            }
        }


        private void Form1_FormClosing(object sender, FormClosingEventArgs e)//-------C#の場合　イベントハンドラの設定を　Form1のプロパティーで設定する。（Basicでは自動的に設定）
        {
            if (MessageBox.Show("Save Setting ?", "", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
            {
                String SetPara = Application.UserAppDataPath + "Set_Ocillo_c.ini";
                try
                {
                    using (StreamWriter F_Oci = new System.IO.StreamWriter(SetPara, false, System.Text.Encoding.Default))
                    {
                        F_Oci.WriteLine(comboBoxPort.Text);
                        F_Oci.WriteLine(comboBoxMode.Text);
                        F_Oci.WriteLine(comboBoxTscale.Text);
                        F_Oci.WriteLine(textBoxTime.Text);

                        if (radioButtonUp.Checked == true) { F_Oci.WriteLine("true"); }
                        else { F_Oci.WriteLine("false"); }

                        if (radioButtonDown.Checked == true) { F_Oci.WriteLine("true"); }
                        else { F_Oci.WriteLine("false"); }

                        F_Oci.WriteLine(comboBoxTrigger.Text);

                        if (checkBoxEXT.Checked == true) { F_Oci.WriteLine("true"); }
                        else { F_Oci.WriteLine("false"); }

                        F_Oci.WriteLine(comboBoxRange.Text);
                        F_Oci.WriteLine(DataDir);
                        F_Oci.WriteLine(DataFile);
                        F_Oci.WriteLine(DataNo);
                        F_Oci.WriteLine(ZeroR0);
                        F_Oci.WriteLine(ZeroR1);
                        F_Oci.WriteLine(ZeroR2);
                        F_Oci.WriteLine(Vref);
                    }
                }
                catch (Exception ex) { toolTip1.Show(ex.Message, this, 100, 44, 300000); }
            }

            Microsoft.Win32.SystemEvents.PowerModeChanged -= new Microsoft.Win32.PowerModeChangedEventHandler(SystemEvents_PowerModeChanged);
            //-------スリープのイベントハンドラの削除

        }


        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }


        private void dataFileToolStripMenuItem_Click(object sender, EventArgs e)
        {

            // 連続ファイル名　　***_##.csv　　##=00～99

            DataNo = Interaction.InputBox("How many files for data ?");  // Microsoft.VisualBasic の　InputBox の利用
            if (DataNo != "")
            {

                if (DataNo == "0") { DataNo = "1"; }
                if (Convert.ToInt32(DataNo) > 100) { DataNo = "100"; }
                DataNoB = 0;
                if (DataDir == "") { DataDir = Application.UserAppDataPath; }
                OpenFileDialog ofd = new OpenFileDialog();
                ofd.FileName = "";
                ofd.InitialDirectory = DataDir;
                ofd.Filter = "全てのファイル(*.*)|*.*|CSVファイル(*.csv)|*.csv";
                ofd.FilterIndex = 2;
                ofd.Title = "格納するファイル名を設定してください";
                ofd.CheckFileExists = false;
                if (ofd.ShowDialog() == DialogResult.OK)
                {
                    DataFile = ofd.FileName.Substring(0, (ofd.FileName.Length - 4));
                    DataDir = ofd.FileName;
                }
                else { DataNo = ""; }
            }
        }


        private void zeroToolStripMenuItem_Click(object sender, EventArgs e)
        {

            if (Measure == 0)
            {
                serialPort.PortName = comboBoxPort.Text;
                serialPort.DtrEnable = true;
                serialPort.RtsEnable = true;
                serialPort.Open();
                if (MessageBox.Show("Short-circuit Input.  Ready ?", "", MessageBoxButtons.OKCancel) == System.Windows.Forms.DialogResult.OK)
                {
                    ZeroR0 = GetVin("R0");
                    ZeroR1 = GetVin("R1");
                    ZeroR2 = GetVin("R2");
                }
                serialPort.Close();
                textBox1.Text = "Zero=" + Convert.ToString(Convert.ToInt32(ZeroR0) - 512);
            }
        }

        private String GetVin(String Range)   //   電圧値取得　４回平均　ゼロ点バイアスはそのまま
        {
            Command(Range);
            int a = 0;
            for (int i = 1; i <= 4; i++)
            {
                Command("QQ");
                while (serialPort.BytesToRead < 2) { }

                serialPort.Read(RdChr, 0, 2);
                int b = RecNum();
                while (serialPort.BytesToRead < 3) { }

                serialPort.Read(RdChr, 0, 3);
                b = (b * 4 + RecNum() / 64);
                a += b;
            }
            a /= 4;
            return Convert.ToString(a);
        }


        private void reference185VToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Measure == 0)
            {
                serialPort.PortName = comboBoxPort.Text;
                serialPort.DtrEnable = true;
                serialPort.RtsEnable = true;
                serialPort.Open();
                if (MessageBox.Show("Input Standard Voltage.  Ready ? ", "", MessageBoxButtons.OKCancel) == System.Windows.Forms.DialogResult.OK)
                {
                    Vref = GetVin("R1");
                    textBox1.Text = "Vref=" + Convert.ToString(Convert.ToInt32(Vref) - 512);
                }
                serialPort.Close();
                Vscale = Convert.ToSingle(comboBoxRange.Text);
            }
        }


        private void versionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            serialPort.PortName = comboBoxPort.Text;
            serialPort.DtrEnable = true;
            serialPort.RtsEnable = true;
            serialPort.Open();
            Command("MM");

            MessageBox.Show("（株）島津総合科学研究所" + "\n" + "ssrOS1 System version = " + Version + "\n" +
               "ADunit Version = " + serialPort.ReadLine());

            serialPort.Close();

        }


        private void onlineManualToolStripMenuItem_Click(object sender, EventArgs e)
        {
            String d = "http://www.shimadzu.co.jp/ssr/etc/ssrOsc/help.pdf";

            Help.ShowHelp(textBox1, d);
        }


        private void aDunitCheckToolStripMenuItem_Click(object sender, EventArgs e)
        {
            String a, b;
            serialPort.PortName = comboBoxPort.Text;
            serialPort.DtrEnable = true;
            serialPort.RtsEnable = true;
            serialPort.Open();

        Repeat:
            a = Interaction.InputBox("Input Command ");
            if (a != "")
            {
                Command(a);
                b = a + " / " + RdChr[0] + RdChr[1];
                if (a == "QQ" || a == "MM") { b = b + " / " + serialPort.ReadLine(); }
                textBox1.Text = b;
                goto Repeat;
            }

            serialPort.Close();
        }


        private void portToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (String sp in System.IO.Ports.SerialPort.GetPortNames())
            {
                comboBoxPort.Items.Add(sp);
                comboBoxPort.Text = sp;
            }

        }

        private void comboBoxPort_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

    }

}
